package ch.zhaw.gartenverwaltung;

import ch.zhaw.gartenverwaltung.bootstrap.AppLoader;
import ch.zhaw.gartenverwaltung.backgroundtasks.BackgroundTasks;
import ch.zhaw.gartenverwaltung.io.CropList;
import ch.zhaw.gartenverwaltung.io.PlantList;
import ch.zhaw.gartenverwaltung.io.TaskList;
import ch.zhaw.gartenverwaltung.models.Garden;
import ch.zhaw.gartenverwaltung.types.Crop;
import javafx.application.Application;
import javafx.stage.Stage;

import java.io.IOException;
import java.util.Timer;

public class Main extends Application {
    Timer backGroundTaskTimer = new Timer();
    BackgroundTasks backgroundTasks;

    @Override
    public void start(Stage stage) throws IOException {
        AppLoader appLoader = new AppLoader();

        backgroundTasks = new BackgroundTasks((TaskList) appLoader.getAppDependency(TaskList.class),(CropList) appLoader.getAppDependency(CropList.class), (PlantList) appLoader.getAppDependency(PlantList.class));
        // TODO reduce period
        backGroundTaskTimer.scheduleAtFixedRate(backgroundTasks, 0, 1000);

        appLoader.loadSceneToStage("MainFXML.fxml", stage);

        stage.setTitle("Gartenverwaltung");
        stage.show();
    }

    @Override
    public void stop(){
        backGroundTaskTimer.cancel();
    }

    public static void main(String[] args) {
        launch();
    }
}